#include "kurt_sim_cam_client.h"
#ifdef USARSIM
#include "sim/kurt_sim_client.h"
extern kurt_sim_client sim_client;
#endif
extern ConfigFileKurt MyConfigFileKurt;
/*
 * Init Sim Client for Camera
 */
void kurt_sim_cam_client::init_cam_client(int port) {

  // Init Client
  cout << "USAR_CAM_CLIENT: Init Cam Client" << endl;

  // Create Socket
  cam_sock = socket(AF_INET, SOCK_STREAM, 0);
  if (cam_sock == -1) {
    cout << "USAR_CAM_CLIENT Error: No Socket" << endl;
    exit(0);
  }

  // Create Connection
  c_addr.sin_addr.s_addr = inet_addr(MyConfigFileKurt.Get_USAR_Cam_IP());
  c_addr.sin_port = htons(port);
  c_addr.sin_family = AF_INET;

  // Connect over Port
  cout << "USAR_CAM_CLIENT: Waiting for Connection on Port: " << port << flush;
  while (connect(cam_sock,(struct sockaddr*)&c_addr,sizeof(c_addr))!=0) {
    cout << "." << flush;
    usleep(1000000);
  }
  cout << endl;
  cout << "USAR_CAM_CLIENT: Connected to Server" << endl;
}
/*
 * Send grab command over (W)LAN from Kurt to CamServer
 */
int kurt_sim_cam_client::grab_images(int cameraNum) {
  static long double TimeDiff=0.0;
  TimeDiff += Get_mtime_diff(8);
  //Timeintervall for grab Command
  if (TimeDiff > 400) {
    TimeDiff = 0;
    if( cameraNum == 0 ){
	 if(send(cam_sock, "G", 1, 0) < 0) {
	   return 0;
	 }
    }
    else if( cameraNum == 1 ) {
	 if(send(cam_sock, "H", 1, 0) < 0) {
	   return 0;
	 }
    }
    return -5;
  }
  return 0;
}
/*
 * Get Image from Socket
 */
int kurt_sim_cam_client::save_images(const char* filename) {
  l=0;
  im_bild=false;
  while(recv(cam_sock, rec_buf, 1, 0) > 0) {
    if(!im_bild && rec_buf[0] == (char)0xd8 && buf[0] == (char)0xff) {
      l++;
      im_bild = true;
    }
    else if(im_bild && buf[l-1] == (char)0xff && rec_buf[0] == (char)0xd9) {
      buf[l] = rec_buf[0];
      l++;
      break;
    }
    buf[l] = rec_buf[0];
    if(im_bild) {
      l++;
    }
  }
  if(im_bild) {
    save_pic_file.open(filename, ios::out|ios::binary);
    if (save_pic_file.good()) {
      save_pic_file.write(buf, l);
      save_pic_file.close();
      save_pic_file.clear();
	 return 2;
    }
  }
  return 1;
}
/*
 *Close connetion to CamServer
 */
void kurt_sim_cam_client::close_cam_client() {
  // Close Client-Socket
  close(cam_sock);
  cout << "USAR_CAM_CLIENT: Close Position Socket" << endl;
}
