#ifndef KURT_SIM_CAM_CLIENT_H
#define KURT_SIM_CAM_CLIENT_H

#include <iostream>
#include <string>
#include <fstream>

#include <fcntl.h>

#include <stdlib.h>
#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <asm/types.h>
#include <unistd.h>
#include <stdint.h>

#include <linux/input.h>

#include <netdb.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <fstream>

#include "ConfigFileKurt.h"
#include "mytime.h"

using namespace std;


// Class sim_client
class kurt_sim_cam_client {

public:
  /**
   * init Cam Client on the given port
   */
  void init_cam_client(int port);
  /**
   * Send grab command over (W)LAN from Kurt to CamServer
   * @param cameraNum 1 for grab left camera 2 for grab right camera
   */
  int grab_images(int cameraNum);
  /**
   * Get Image from Socket and stores it in the given filename
   * @param filename the filename to store the image
   */
  int save_images(const char* filename);
  /**
   * Close connetion to CamServer
   */
  void close_cam_client();

private:
  struct sockaddr_in c_addr;
  
  /// Cam Client
  int cam_sock;
  /// image Buffer
  char buf[1000000];
  /// for image saving
  char rec_buf[1];
  int l;
  /// for image saving
  bool im_bild;
  /// for image saving
  ofstream save_pic_file;
};

#endif
/* End of File */

